const std = @import("std");

// Although this function looks imperative, note that its job is to
// declaratively construct a build graph that will be executed by an external
// runner.
pub fn build(b: *std.Build) void {
    const target = b.standardTargetOptions(.{});
    const optimize = b.standardOptimizeOption(.{});
    const zynacor = b.addExecutable(.{
        .name = "zynacor",
        .root_source_file = b.path("src/main.zig"),
        .target = target,
        .optimize = optimize,
    });
    const checker = b.addExecutable(.{
        .name = "checker",
        .root_source_file = b.path("src/checker.zig"),
        .target = target,
        .optimize = optimize,
    });

    b.installArtifact(zynacor);
    b.installArtifact(checker);
}
