const std = @import("std");

const sums: [8][]const u8 = .{
    "76ec2408e8fe3f1753c25db51efd8eb3",
    "0e6aa7be1f68d930926d72b3741a145c",
    "7997a3b2941eab92c1c0345d5747b420",
    "186f842951c0dcfe8838af1e7222b7d4",
    "2bf84e54b95ce97aefd9fc920451fc45",
    "e09640936b3ef532b7b8e83ce8f125f4",
    "4873cf6b76f62ac7d5a53605b2535a0c",
    "d0c54d4ed7f943280ce3e19532dbb1a6"
};

pub fn main() !void {
    var gpa = std.heap.GeneralPurposeAllocator(.{}).init;
    const allocator = gpa.allocator();
    var args = try std.process.argsWithAllocator(allocator);
    defer args.deinit();

    var input: []const u8 = undefined;

    // Skip arg[0]
    _ = args.skip();

    const argVal = args.next();
    if (argVal) |a| {
        input = a;
    } else {
        std.debug.print("USAGE: checker ANSWER\n", .{});
        std.process.exit(1);
    }
    
    var hasher = std.crypto.hash.Md5.init(.{});
    var buf: [std.crypto.hash.Md5.digest_length]u8 = undefined;
    hasher.update(input);
    hasher.final(buf[0..]);
    const digest = try std.fmt.allocPrint(allocator, "{x}", .{std.fmt.fmtSliceHexLower(&buf)});

    var matched = false;
    for (sums, 0..) |sum, i| {
       if (std.mem.eql(u8, digest, sum)) {
           std.debug.print("CORRECT! {s} matches sum #{d}: {s}\n", .{input, i, sum});
           matched = true;
           break;
       }
    }

    if (!matched) {
        std.debug.print("FAILURE! {s} matches no sums\n", .{input});
    }

    allocator.free(digest);
}

